package BigMac::bigmac;

use 5.008;
use warnings;

require Exporter;

our @ISA = qw(Exporter);

#CS8761, Fall 2002
#Group Project
#Bigmac dictionary Interface module
#Group-   Sport Boys
#         Aniruddha Mahajan
#         Anushree Parsekar
#         Prashant Rathi
#         Victoria Harp          


# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.

# This allows declaration	use bigmac ':all';
# If you do not need this, moving things directly into @EXPORT or @EXPORT_OK
# will save memory.
our %EXPORT_TAGS = ( 'all' => [ qw(
	
) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

@EXPORT = qw(get_hash get_word_info get_nouns get_adjectives get_adverbs get_verbs get_defn get_by_value get_pos );

our $VERSION = '0.01';


# Preloaded methods go here.

# Autoload methods go after =cut, and are processed by the autosplit program.

# Function Description
# This function just creates a hash for all the dictionary entries.The hash once created improves the access for
# further queries made and outputs the results faster.
sub get_hash 
{
    $filename ="/home/cs/tpederse/CS8761/BigMac/bigmac.corrected2.sgml";                     # Open the Bigmac File
    open(FILE,$filename);
    while ($line =<FILE>)
    {
	if($line =~ m/<HEAD>(.*?)(<(.*?)>)*?<\/HEAD>/g)                                      # Get the word and using it as a key
	{                                                                                    # create a hash
	    $word = $&;
	    $word =~ s/(<HEAD>|<\/HEAD>)//g;
	    $word =~ s/<SUP>[0-9]*<\/SUP>//g;
            if($line =~ m/<\/RECORD>/g)
	    {
		$newline = $`.$&.$' ;
		$data{$word} .= $newline;                                                    # Put the entry for the word as the value
	    }                                                                                # for the key
	}
    }    
    close(FILE);                                                                             # Close the file
}

# Function Description 
# This function implements the Query by word option.The word is the parameter passed to the function.
# It returns all the necessary information like the word definition, pronunciation, parts of speech,
# inflections , synonyms as in the thesauras and the languages.

sub get_word_info 
{
    $ret =" ";
    $word = $_[0];                                                                          # Get the word to be queried 
    chomp($word);                                                                             
    $line1 = $data{$word};
    if(!$line1)                                                                             # Check if the word exists in the dictionary
    {                                                                                       # If not ,exit
	$ret.= " *** No Entry for the word *** ";                                          
	return ($ret);
    }
    $line1 =~ s/\n//g;                                                                      # Removing newline characters from the entry
    $line = $line1;
    $ret .= "HEADWORD -- $word\n";  
    while($line =~ m/<PRN TYPE=SAY>(.*?)<\/PRN>/g)                                          # Pronunciation of the word
    {
	$value =$1;
	$line=$';
	$ret .= "\nPRON ---- $1 \n";                      
	$ret.=  "\n";
    }
    $line= $line1;
    while($line =~ m/<INFLECTION>(.*?)<\/INFLECTION>/g)                                     # Search for inflections of that word
    {
	$value =$1;
	$line =$'; 
	while($value =~ m/<INF (.*?)>(.*?)<\/INF>/g)                                        # Display all inflections
	{
	    $ret .= "INFLECTION  --  $2 \n";
	    $value1 = $';
	}
        $ret .= "\n";
    }
    $line=$line1;
    while($line =~ m/<CHUNK>(.*?)<\/CHUNK>/g)                                               # Get the chunk
    {
	$value =$1;
	$line =$'; 
	$value =~ m/<POS>(.*?)<\/POS>/g;                                                    # extract the part of speech  
	$ret.= "\nPART OF SPEECH -- <POS>$1</POS> \n";            
	$value1 =$' ;
        $ret.= "DEFINITION : \n";
	while($value1 =~ m/<DTEXT>(.*?)<\/DTEXT>/g)                                         # definition associated with the
	{                                                                                   # part of speech
	    $definition =$1;
	    $definition =~ s/<(.*?)>//g;
	    $ret.= "<DEF> --$definition </DEF>\n";                                                     # Display all definitions
	    $value1 = $';  #'
	}            
    }
    $ret .= "\n";
    $line = $line1; 
    $ret.= "Related Words :\n ";              # Searching for synonyms in thes.data file
    $ret.= "<RELATED>";
    while($line1 =~ m/<THES>(.*?)<\/THES>/g)                                                # Get the thes code
    {
	$flag=1;
	$value =$1;
	$line =$';  #'
	$value =~ s/\*//g;
        #$ret.= " THES CODE --- $value \n";                               # Get the corresponding entries from thes.data
        $answer = convert_thes_entry($value);                                               # file
        $ret .= " $answer\n";
    }
    $ret .= "<WORDS>";
    $ret .= "\n";
    $line = $line1;
    $ret .= "LANG: \n\n";                                                # Search for language origins of a particular word
    while($line =~ m/<LANG>(.*?)<\/LANG>/g)
    {
	$value =$1;
	$line=$'; #'
        if(!($ret =~ m/$value/g))
	{
	    $ret .= "---- $value";     
        }
	$ret.=  "\n";
    }
    return($ret);                                                           # Return all the word information as a string
}   

# Function Description
# This function returns the list of all nouns present in the dictionary and outputs them into a file.
sub get_nouns
{    
    foreach $word(keys %data)                                                              # Search all words
    {
	$line = $data{$word};
        $line =~ s/\n//g;
	while($line =~ m/<CHUNK>(.*?)<\/CHUNK>/g)                                          # extract the chunk
	{
	    $value =$1;
            $line =$';           #'
	    if($value =~ m/<POS>(.*?)<\/POS>/g)                                            # get the part of speech  
	    {
		$key =$1; 
                if($key eq 'noun')                                                         # check if noun
		{
		    $noun{$word}++;
		}
	    }
        
	}
    }
    return(%noun);                                                                         # return the hash for all nouns
}

# Function Description
# This function returns the list of all adjectives present in the dictionary and outputs them into a file.
sub get_adjectives
{    
    foreach $word(keys %data)                                                              # Search all words
    {
	$line = $data{$word};                                      
        $line =~ s/\n//g;
	while($line =~ m/<CHUNK>(.*?)<\/CHUNK>/g)                                          # extract the chunk
	{
	    $value =$1;
            $line =$';          #'
	    if($value =~ m/<POS>(.*?)<\/POS>/g)                                            # get the part of speech 
	    {
		$key =$1; 
                if($key eq 'adjective')                                                    # check if adjective
		{
		    $adjective{$word}++;
		}
	    }
        
	}
    }
    return(%adjective);                                                           # return the hash for all adjectives
}

# Function Description
# This function returns the list of all adverbs present in the dictionary and outputs them into a file.
sub get_adverbs
{    
    foreach $word(keys %data)                                                              
    {
	$line = $data{$word};                                                              # Search all words
        $line =~ s/\n//g;
	while($line =~ m/<CHUNK>(.*?)<\/CHUNK>/g)                                          # extract the chunk
	{
	    $value =$1;
            $line =$';          #'
	    if($value =~ m/<POS>(.*?)<\/POS>/g)                                            # get the part of speech 
	    {
		$key =$1; 
                if($key eq 'adverb')                                                       # check if adverb
		{
		    $adverb{$word}++;
		}
	    }
        
	}
    }
    return(%adverb);                                                                       # return the hash for all adverbs
}



# Function Description
# This function returns the list of all verbs present in the dictionary and outputs them into a file.
sub get_verbs
{    
    foreach $word(keys %data)                                                              # Search all words
    {
	$line = $data{$word};
        $line =~ s/\n//g;
	while($line =~ m/<CHUNK>(.*?)<\/CHUNK>/g)                                          # extract the chunk
	{
	    $value =$1;
            $line =$';   #'       
	    if($value =~ m/<POS>(.*?)<\/POS>/g)                                            # get thepart of speech 
	    {
		$key =$1; 
                if($key eq 'verb' | $key eq 'verb (t)' | $key eq 'verb(i)')                # check if verb 
		{
		    $verb{$word}++;                      
		}
	    }
        
	}
    }
   
    return(%verb);                                                                         # return the hash for all verbs
}

# Function Description
# This function takes an array of words as parameters.It searches the dictionary definitions for all
# these words and returns the headword, part of speech,and the THES code that pertain to that definition. 
sub get_defn
{
    $ret ="\n";
    @elements = @_;                                                       # all the words to be searched are in the array
    foreach $word(keys %data)
    {
	$line = $data{$word};                                             # for each word ..get the entry for the word
        $line =~ s/\n//g;
    	while($line =~ m/<CHUNK>(.*?)<\/CHUNK>/g)                                          # chunk
	{
	    $value =$1;
            $line =$'; #'
	    $value =~ m/<POS>(.*?)<\/POS>/g;                                               # get the part of speech
            $pos =$1;  
	    $pos =~ s/<(.*?)>//g;
            $value2 =$' ;
	    while($value2 =~ m/<DEF id=[0-9]+>(.*?)<\/DEF>/g)                      # get the definition for that word
	    {
		$value1 = $1;
	        $value2= $'; 
		while($value1 =~ m/<DTEXT>(.*?)<\/DTEXT>/g)     
		{
		    $definition =$1;  
		    $definition =~ s/<(.*?)>//g;                                         
		    $count =0;                                              # here we check whether the definition contains
		    $value1 = $';                                                          #' all the words
		    for($i=0;$i<=$#elements;$i++)
		    {
			if($definition =~ m/\b$elements[$i]\b/g)
			{
			    $count++;                                # increment the count if there is the required word
			}
		    }
		    if ($count == $#elements+1)                             # If it contains all the necessary words
		    {
			$ret .= "HEADWORD ----- $word\n";                   # then only print the headword, part of speech
			$ret .= "POS ---- $pos\n";
			$ret .= "DEFN ---- $definition\n";                                 # definition
			$ret .= "\n";
			#Still to do thes code 
			$thes_entry = $';
			$check =$';
                        if($check =~m/<THES>(.*?)<\/THES>/g)
			{
			    $ret.= " THES ENTRIES -- \n";
                        }
			while($thes_entry =~ m/<THES>(.*?)<\/THES>/g)             # we also find the thes codes associated
			{
			    $flag=1;
			    $value =$1;
			    $line =$';  #'
			    $value =~ s/\*//g;
			    if(!($ret =~ m/$value/g))
			    {
				$answer = convert_thes_entry($value);                     # this function returns the corr
				$ret .= $answer;                                          # entries in thes.data
			    }   
			}
			$ret .= "\n";
		    }
		}    
	    }            
        }
    }
    return($ret);                                                                # return the string to be printed as output
}

# Function Description
# This function takes a word as a parameter.It finds all the words that share the same value(thes code)
# and returns these words categorized by their values (thes-codes).
sub get_by_value
{
    $ret = "\n";                                                                          # Get the parameter word 
    $word = $_[0];
    chomp($word);                                                               # Get the entry for that word from the hash 
    $line = $data{$word};
    $flag =0;
    %thes_code =();
    while($line =~ m/<THES>(.*?)<\/THES>/g)                                    # Search for all the thes codes for that word
    {
	$flag=1;
	$value =$1;
	$line =$';  #'
	$value =~ s/\*//g;
        $thes_code{$value}++;                                           # multiple thes code values are stored in the hash
    }
    if($flag == 0)
    {
	$ret .= "No thes code found for -- $word \n ";                                    # check if thes code exists
	return($ret);
    }
    foreach $x(keys %thes_code)                                               # for each thes code find all the words that 
    {                                                                                     # have the same thes code
	$ret .= $x;
        $ret .= "\n";
	foreach $word(keys %data)
	{
	  $line = $data{$word};
	  while($line =~ m/<THES>(.*?)<\/THES>/g)
	  {
	      $value =$1;
	      $line = $';  #'
	      $value =~ s/\*//g;
	      if($value eq $x)
              {
		  if(!($ret =~ m/ $word /g))                                              # check for repetition 
		  {
		      $ret .= "$word " ;
		  }
              }
	  }
        }
	$ret .="\n";
    }
    return ($ret);                                                 # return all the words categorized by matching thes code 
}

# Function Description
# This is a supplementary function which takes a thes code and returns the corresponding
# entries from the thes.data file.
sub convert_thes_entry
{
    $syn =$_[0];                                                                # get the thes code in proper format
    @num = split/\./,$syn;
    $num[0] =~ s/^0//g;                                                      # removing the leading zeroes in first two nos.
    $num[1] =~ s/^0//g;
    $num[2] =~ s/(^0)|(0$)//g;                                       # and the lagging or leading zeroes in the third no.
    $key_num = $num[0].".".$num[1].".".$num[2];
    $thes_filename ="/home/cs/tpederse/CS8761/BigMac/thes.data";       # loooking for identical mapping in thes.data
    open(THES,$thes_filename);
    $ret1 = " ";
    while($next_line=<THES>)
    {
	if($next_line =~ m/$key_num/g)
	{
	    @synonym = split/\|/,$';                                                      #' get the synonym
	    $synonym[3] =~ s/<(.*?)>//g;
	    if(!($ret1 =~ m/ $synonym[3] /g))                                             # check for repetition
	    {
		$ret1 .= "$synonym[3] ";
	    }
	    last;
	}
    }
   return($ret1);                                                         # return all the matching entries as a string
}
# Function Description
# This is a function which checks a word for a particular part of speech.It takes the word and the 
#part of speech and returns 1 if the word has that part of speech else it returns 0.
sub get_pos
{
    $ret ='';
    $word= $_[0];                                                            #the word
    $pos = $_[1];                                                            #the part of speech to be checked for
    chomp($word);                                                                             
    $line1 = $data{$word};
    if(!$line1)                                                             # Check if the word exists in the dictionary
    {                                                                       # If not ,exit
	$ret.= " *** No Entry for the word *** ";                      
	return 0;
    }
    $line1 =~ s/\n//g; 
    while($line1 =~ m/<POS>(.*?)<\/POS>/g)                                  #extract all the parts of speech for the word    
    {
	$value =$1;
	$line1=$';                                                          #'
	$ret .= "$1";                      
	$ret .= "\n";
    }        
    if($ret =~ m/$pos/g)                                                    #if the word has the particular part of speech
    {
	return 1;                                                           #return 1
    }
    else
    {
	return 0;                                                           #else  return 0
    }
}

1;
__END__

=head1 NAME

BIGMAC - Perl module for querying the Macquarie Dictionary

=head1 DESCRIPTION

The module is an interface to the BigMac dictionary.It provides various
functions to get the required data from the dictionary.  The function
descriptions are given above.

=head1 SYNOPSIS

FUNCTION: B<get_hash()>

   This function is to be called at the beginning of the program so that a
   hash is created for all the dictionary entries.  This speeds up further
   queries made to the dictionary.

FUNCTION: B<$info = get_word_info($word)>

   This function takes a word as input and returns all the important
   information such as definition, pronunciation, inflections, parts of
   speech, language origin and related words for the thesaurus.

   EXAMPLE: $info = get_word_info('abash')

   All the information for the word 'abash' is returned in the $info
   variable.

FUNCTION: B<%hash = get_nouns()>

   This function returns all the nouns present in the dictionary. The
   result can be printed to a file which we will contain all nouns.  The
   hash contains the list of all the nouns.

FUNCTION: B<%hash = get_adjectives()>

   This function returns all the adjectives present in the dictionary.The
   result can be printed to a file which we will contain all adjectives.
   The hash contains the list of all the adjectives.

FUNCTION: B<%hash = get_adverbs()>

   This function returns all the adverbs present in the dictionary.The
   result can be printed to a file which we will contain all adverbs.  The
   hash contains the list of all the adverbs.

FUNCTION: B<%hash = get_verbs()>

   This function returns all the verbs present in the dictionary.The result
   can be printed to a file which we will contain all verbs. The hash
   contains the list of all the verbs.

FUNCTION: B<$match = get_defn(@words)>

   This functions takes an array of words as input.  It searches for all of
   these words in the dictionary definitions.  It returns the headword,
   part of speech, definition, thes values for the those defintions which
   contain all the above words.  All the matching definitions and their
   necessary information is returned in the $match variable for all the
   definitions which contain the words in the @words array.

   EXAMPLE: If the words are "repeat" and "in" then all the definitions
   which contain these words will be returned.

FUNCTION: B<$entries = get_by_value($word)>

   This function takes a word as input.  It finds all the thesaurus codes
   for this word and returns all the other words from the dictionary which
   contain the same thes values. If the word has multiple thes codes, all
   the entries pertaining to that thes-code are categorized and separate
   lists are returned.

   EXAMPLE: If the $word = 'abash' then all the thes codes for abash are
   found.  If there are three thes codes for 'abash' then all the words
   matching for a particular thes code are returned.

FUNCTION: B<convert_thes_entry()>

   This function is used by the other functions in the module.  It cannot
   be called separately. It returns the thes_entry from the thes_data file
   for the thes_code provided to it.

FUNCTION: B<$ flag=get_pos()>

   This function checks if a particular word has a particular part of speech
   If it has,it returns 1 else returns 0.
   
  EXAMPLE: If the word is "excellent" and part of speech is "adjective".It
  returns 1 if excellent is adjective else it returns 0.
=head1 EXPORT

get_hash()       Creates Hash for the data

get_word_info()  Opens dictionary files in and returns requested information.

get_nouns()      Returns all nouns

get_verbs()      Returns all verbs

get_adverbs()    Returns all adverbs

get_adjectives() Returns all adjectives

get_defn()       Returns definitions containing the particular words

get_by_value()   Returns all the words that share the same value(thes code)

=head1 BACKGROUND INFORMATION

The Macquarie Dictionary was developed in Australia by the Lingustics
Department of Macquarie Univeristy in 1981.  It was targeted towards
primary and secondary students.  Since then, the dictionary has become
encyclopedic, adding biographical and geographic information along with
illustrative sentences from Australian literature.  (Reference 1)

=head1 SEE ALSO

See QueryData.pm in /usr/local/WordNet-1.7.1/bin

=head1 REFERENCES

  1.  http://www.macquariedictionary.com.au
  2.  mactags.html file provided with Bigmac

=head1 AUTHORS

Aniruddha Mahajan, Anushri Parsekar, Prashant Rathi, and
Victoria Harp. 

=head1 COPYRIGHT AND LICENSE

Copyright 2002 by Aniruddha Mahajan, Anushri Parsekar, Prashant Rathi, and
Victoria Harp.

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself. 

=cut
