package LDOCE::ldoce;
use 5.008;
use warnings;
require Exporter;
our @ISA = qw(Exporter);



# CS8761, Fall 2002
# Group Project
# LDOCE Dictionary interface module
# Group - SPORT BOYS
#         Aniruddha Mahajan
#         Anushri   Parsekar
#         Prashant  Rathi
#         Victoria  Harp         
#         


# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.

# This allows declaration	use ldoce ':all';
# If you do not need this, moving things directly into @EXPORT or @EXPORT_OK
# will save memory.
our %EXPORT_TAGS = ( 'all' => [ qw(
	
) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(lget_word_info createhash all_sub_codes words_of_sub_codes words_in_defs);

our $VERSION = '0.01';

# Preloaded methods go here.

# Autoload methods go after =cut, and are processed by the autosplit program.


sub words_in_defs                                      # function to return words which contain, in their
{                                                      #   defns all of the entered words 
    $wstring = $_[0];
    @warray = split/ /, $wstring;
    $ret = '';    
    foreach $word (keys %allhash)
    { 
        $ret1 = '';
	$wd = $allhash{$word};                          # get entry corresponding to word
	$wd =~ s/\n//g;                                 # take out newlines
	$line = $wd;                       
	while($line =~ m/<POS>(.*?)<\/POS>/g)           # while entry contains part-of-speech tag 
	{   $ret1 = '';
            $ret1 .= "-----------------------------------------------------------------------------------------------------\n"; 
	    $ret1 .= "HEADWORD -- $word\n";   
	    $value =$1;  
	    $line=$';                    #'             # consider remaining entry     
	    $ret1 .= "POS - $1 \n";                      # print it 
	    $sense_count =0;
	    while($line =~ m/<Sense>(.*?)<\/Sense>/)    
	    {
		$line= $'; #'
		$new_line = $1;       
                if($sense_count==0)
		{
		    if($new_line =~ m/<DEF>(.*?)<\/DEF>/)
		    {  
			#$ret1 .= "DEF ";                      # print DEF of above Sense                    
		    }   
		    while($new_line =~ m/<DEF>(.*?)<\/DEF>/)
		    {   $kk = $1; $count = 0;                 
			$new_line = $';    #'                 # consider entry after DEF
			for($i=0;$i<=$#warray;$i++)
			{
			    if($kk =~ m/ $warray[$i] /)
			    {  
				$count++;    
			    }
			}
			if($count == $#warray+1)
			{ $ret1 .= "DEF   -$kk";                        
			  $ret .= "$ret1\n";
		      }                   		                		   
		    } 		
		}
              
		$sense_count =1;
	    }
	 } #end of while  
    
    } #end of foreach
    $ret =~ s/<(.*?)>//g;
    if($ret eq "")
    {
       $ret = "No such words found!\n";  
    }
    return $ret;
}


sub words_of_sub_codes                              # function to return words having subject codes same as 
{                                                   #          those of given word
    my $word = $_[0];
    chomp($word);                              
    $ret = '';                                      # return var null    
    $wd = $allhash{$word};                          # get entry of entered word in $wd from allhash
    $wd =~ s/\n//g;                                 # take out newlines
    
    while($wd =~ m/<FIELD>(.*?)<\/FIELD>/)          # while entry of entered word contains <FIELD> (subject code)
    {
	$subhash{$1}++;                             # enter subject code in hash
        $wd = $';       #'
    }
    foreach $field (keys %subhash)                  # for every subj code of entered word ..
    {  
        $ret .= "SUBJECT CODE: $field\n";
        foreach $words (keys %allhash)              # for every word in dictionary ..  
        {
	    $line =  $allhash{$words};              # get entry of current word
	    $line =~ s/\n//g;                       # take out newlines
	    while($line =~ m/<FIELD>(.*?)<\/FIELD>/)# while entry contains <FIELD> & </FIELD> (subject code)
	    {
                if($1 eq $field)                    # if subj code of current word equals subj code of entered word
                {
                    if(!($ret =~ m/ $words /))
                    {
                       $ret .= "$words\n"; 
		    }
                } 
                $line = $';  #'                            
	    }
	}
    }
    $ret =~ s/<(.*?)>//g; 
    return $ret;
}


sub all_sub_codes                                   # function to find all subj codes present in dictionary
{   
   $ret = '';                                       # return var to null 
   foreach $words (keys %allhash)                   # for all words present in the dictionary ..
   {   
       $line = $allhash{$words};                    # get entry of current word
       $line =~ s/\n//g;                            # remove newlines
       while($line =~ m/<FIELD>(.*?)<\/FIELD>/)     # while entry of current word contains <FIELD> (subject code)
       {  
           $fields{$1}++;                           # enter subject code in hash
           $line = $';  #'
       }
   }           
   foreach $field (keys %fields)                    
   {
       $ret .= "$field\n";                          # get subj codes in a var 
   }
   $ret =~ s/<(.*?)>//g;
   return $ret;                                     # return them

}


sub lget_word_info                                   # function to get relevant information of a word
{                                                   #          as supplied by the dictionary

    my $word = $_[0];                               # get word
    chomp($word);                  # PRON, INFLECTYPE, POS-DEF,EXAMPLE, FIELD
    $ret = '';
    $wd = $allhash{$word};                          # get entry corresponding to word
    if(!$wd)                                        # if entry is not present 
    {
	$ret.= " *** No Entry for the word *** ";
	return ($ret);
    }
    $wd =~ s/\n//g;                                 # take out newlines
    $line = $wd;
    $ret .= "HEADWORD -- $word\n";                  # print original word
    while($line =~ m/<PRON>(.*?)<\/PRON>/g)         # while entry contains pronunciation(s)
    {
	$value =$1;  
	$line=$';                    #'                 
	$ret .= "PRONUNCIATION - $1 \n";           # print them       

    }
    $line= $wd;                                     
    while($line =~ m/<INFLECTYPE>(.*?)<\/INFLECTYPE>/g)  
    {
	$value =$1;  
	$line=$';                    #'                 
	$ret .= "INFLECTIONS - $1 \n";              # print inflections
       
    }
    $line = $wd;
    while($line =~ m/<POS>(.*?)<\/POS>/g)           # while entry contains part-of-speech tag 
    {
	$value =$1;  
	$line=$';                    #'             # consider remaining entry     
	$ret .= "POS - $1 \n";                      # print it 
       
	while($line =~ m/<Sense>(.*?)<\/Sense>/)    
        {
	    $line= $'; #'
	    $new_line = $1;       
	    if($new_line =~ m/<DEF>(.*?)<\/DEF>/)
            {  $ret .= "DEF"; }                     # print DEF of above Sense
	    while($new_line =~ m/<DEF>(.*?)<\/DEF>/)
	    {
              $new_line = $';    #'                 # consider entry after DEF
              $ret .= "   - $1 \n";              
              if($new_line =~ m/<EXAMPLE>(.*?)<\/EXAMPLE>/)
              {   $ret .= "EXAMPLE- \n"; }                    # print examples of corresponding DEF, Sense
	      while($new_line =~ m/<EXAMPLE>(.*?)<\/EXAMPLE>/)
	      {
              $new_line = $';    #'
              $ret .= "      -$1 \n";              
             
	      } 
           } 
           
        }
    }  
    $ret =~ s/<(.*?)>//g; #take out noise
    return $ret;
}   



sub createhash
{
    for($i=65;$i<91;$i++)                                       # for A to Z
    {        
         $path ="/home/cs/tpederse/CS8761/LDOCE3/A-Z/sgml/";      
         $j = chr $i;     
         $filenm = $path.$j.".SGM";             
         if($j eq 'E')
         {
	     $j = lc($j);
             $filenm = $path.$j.".sgm";
         }           
	 open(INF,$filenm);
         while ($line =<INF>)
	 {   
             $entr = ''; 
	     if($line =~ m/<HWD>(.+)<\/HWD>/g)           # match word
             {    
		 #$entr .= $line;
                 while(!($line =~ m/<\/Entry>/))
                 {
                     #$line = <INF>;
		     $entr .= $line;
                     $line = <INF>;
                 }
                 $entr .= $line;
                 $allhash{$1} .= $entr;                  # allhash--  keys:word, value:entry           
             }
         }
         close INF;
     }
}

1;
__END__
# Below is stub documentation for your module. You'd better edit it!

=head1 NAME

LDOC - Perl module for querying Longman's Dictionary Of Contemporary
English (LDOCE)

=head1 SYNOPSIS

  STEP 1:  To execute the module..
      
           #!/usr/local/bin/perl -w
           use ldoce;                      
           * refer supplied file interface.pl *

  STEP 2: From the command line, type:
      % perl interface.pl 
      

=head1 DESCRIPTION

The test.pl program uses the ldoc.pm module to look up the target <word> in
the LDOCE dictionary, returning the information specified by the <tag>.

=head1 TAGS

  DEF          Returns the definition.

  Inflections  Returns the forms of the word with possible suffix 
               inflections.  For example, for the word "jar", 
               Inflections returns "jarred" and "jarring."

  POS          Returns the part of speech.  (v [verb], n [noun], 
               adj [adjective], adv [adverb], phr v [proverbial 
               expression], prefix, suffix, prep, conjunction,
               indefinite article, determiner, or interjection.)

  EXAMPLE      Returns examples of the word used in a sentence.

  PRON         Returns the phonetic prouniciation of the word.

  SENSE        Returns a Semantic Code.  There are 1,052 semantic 
               codes which classify over 20,000 of the definitions.  
               For example, the words "baby" and "kid" are classified
               under "CHILD". (Reference 1) 

=head1 POS

   For all values of POS as above.
  

=head1 EXPORT

createhash();                      - creates a hash consisting of all words present in the dictionary as keys
 
$ret = get_word_info($word);       - function to get relevant information of a word as supplied by the dictionary
                                                            
$ret = all_sub_codes();            - function to find all subj codes present in dictionary
 
$ret = words_of_sub_codes($word);  - function to return words having subject codes same as those of given word
       
$ret = words_in_defs($wstring);    - function to return words which contain, in their defns all of the entered words




=head1 BACKGROUND INFORMATION

The Longman Company http://www.longman.com specializes in teaching english
as a second language.  In 1995, they created a dictonary where the
definitions were crafted using only 2,072 different words, which reduced
the liklihood of circular definitions and increased our ability to classify
and group word meanings.  The LDOCE dictionary has 80,280
definitions. (Reference 2)

The LDOCE source file is SGML code with newlines separating information for
each tag.

=head1 SEE ALSO

See QueryData.pm in /usr/local/WordNet-1.7.1/bin

=head1 REFERENCES


  1.  http://www.ecs.soton.ac.uk/~ggc01r/dict

  2.  http://www.longman-elt.com/dictionaries/research/dictres.html

=head1 AUTHORS

Aniruddha Mahajan, Anushri Parsekar, Prashant Rathi, and
Victoria Harp. 

=head1 COPYRIGHT AND LICENSE

Copyright 2002 by Aniruddha Mahajan, Anushri Parsekar, Prashant Rathi, and
Victoria Harp.

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself. 

=cut
