#!/usr/local/bin/perl -w
use vista;


start_program();

sub start_program{
  print "\n";
  print "        +++++++++++++++++++++++++++++++++++++++++      \n";
  print "        + + + Welcome to Alta Vista Search! + + +      \n";
  print "        +++++++++++++++++++++++++++++++++++++++++      \n";
  print "        +   1. Help                             +      \n";
  print "        +   2. Run a Search                     +      \n";
  print "        +   3. Count number of hits found       +      \n";  
  print "        +   0. Quit                             +      \n";
  print "        +++++++++++++++++++++++++++++++++++++++++      \n";
  print "\n  Please enter your choice:  ";
  
  $option = <STDIN>;
  if($option == 1){
    help_program();
  }
  if($option == 2){
    getinfo_program();
  }
  if($option == 3){
    geth();
  }
  if($option == 0){
    quit_program();
    return;
  }
  start_program();
}

sub help_program{
  print "\n";
  print "        +++++++++++++++++++++++++++++++++++++++++      \n";
  print "        + + +            HELP               + + +      \n";
  print "        +++++++++++++++++++++++++++++++++++++++++      \n";
  print "\n";
  print "   Option 2:\n"; 
  print "   This program allows you to recursively search       \n";
  print "   www.altavista.com on the sentence level.            \n";
  print "   Sentences will not be displayed unless all the words\n";
  print "   you specify are found.  Also, the program will not  \n";
  print "   return sentences shorter than 25 characters.        \n";
  print "\n";
  print "   Option 3:\n";
  print "   This option returns the number of hits as found by  \n";
  print "   Alta-Vista when given a query:    word1 NEAR word2  \n";
  print "   This query searches for instances where word2 occurs\n";
  print "   near word1 within a window size of 10.              \n";
  print "\n";
  print "   For more information please see our perldoc file at:\n";
  print "   % perldoc vista.pm                                  \n";
  print "\n";
  
  print "   Press <return> to continue.                         \n";
  <STDIN>;
}

sub getinfo_program{
  print "\n\n";
  print "   Please enter your search words, all on one line,    \n";
  print "   separated by a space.  For example if you want      \n";
  print "   to search for \"black\", \"dog\" and \"run\" you    \n";
  print "   would type:  black dog run                          \n";
  print "\n";
  print "   Order does not matter.\n\n";
  print "   Please enter your words:  ";
  $words = <STDIN>;
  chomp($words);
  $words =~ s/ /+/g; #swap whitespace with +
  print "\n\n";
  print "   Do you want to restrict the search to say n pages?  y/n? ";
  $yn = <STDIN>;
  chomp($yn);
  if($yn eq "y" || $yn eq "Y")
  {
  print "\n\n";
  print "   Please enter no. of pages to be searched....        ";
  $maxpages = <STDIN>;
  }     
  
  print "\n\n";
  print "     ++++++++++++++++++++++++++++++++++++++++++++++      \n";
  print "     +   Where would you like your output sent?   +      \n";
  print "     +       1 = File                             +      \n";
  print "     +       2 = STDOUT                           +      \n";
  print "     ++++++++++++++++++++++++++++++++++++++++++++++      \n";
  print "\n  Please enter your choice:  ";
  
  $outputchoice = <STDIN>;  # get user's choice
  chomp($outputchoice);
  #invoke module, passing concatenated word list 
  if($yn eq "y" || $yn eq "Y")
  {
       $returnval = get_instance($words,$maxpages);
  }
  else
  {
       $returnval = get_instance($words);
  } 
  #if user wishes to print to a file....
  if($outputchoice == 1){
    print "\n\n  Please enter destination file name: ";
    $filename = <STDIN>;
    chomp($filename);
    open(OUT, ">". $filename) || die "$filename not opened.\n";
    print OUT $returnval;
    close(OUT);
  }
 
  #if user wishes to print to STDOUT
  if($outputchoice == 2){
    print $returnval;
  }
}

sub geth{
  print "\n\n";
  print "Please enter word1 and word2 separated by a space..  ";
  $wrds = <STDIN>;
  @wrd = split / /, $wrds;
  $rett = get_hits($wrd[0],$wrd[1]);
  print "\n\n";
  print "No of hits for $wrd[0] NEAR $wrd[1] is :   $rett \n";
}

sub quit_program{
  print "\n\n";
  print "    ++++++++++++++++++++++++++++++++++++++++++++++++++++    \n";
  print "    +      Thank you for using Alta Vista Search!      +    \n";
  print "    +                                                  +    \n";
  print "    +   Sponsored by the letter T and the word \"vex\".  +  \n";
  print "    ++++++++++++++++++++++++++++++++++++++++++++++++++++    \n";
  print "\n"; 
}
